import {Md5} from "ts-md5";
import Cookies from 'js-cookie';

export module OpenSubsonic {
    export let username = "";
    export let password = "";
    let token = "";
    let salt = "";
    export let base = "https://navidrome.neshweb.net";
    const apiVer = "1.16.1"; // Version supported by Navidrome. Variable for easier updating
    const clientName = "Lytter";

    export function getApiPath(path: string) {
        if (username === "") {
            let cookie = Cookies.get("subsonicUsername");
            if (typeof cookie !== "undefined") {
                username = cookie;
            }
        }

        let cookie = Cookies.get("subsonicToken");
        if (typeof cookie !== "undefined") {
            token = cookie;

            cookie = Cookies.get("subsonicSalt");
            if (typeof cookie !== "undefined") {
                salt = cookie;
            }
        }
        else {
            generateToken();
        }

        return `${base}/rest/${path}?u=${username}&s=${salt}&t=${token}&v=${apiVer}&c=${clientName}&f=json`;
    }

    function generateToken() {
        salt = "staticfornow";
        token = Md5.hashStr(password + salt);
    }

    export function storeCredentials() {
        let options = {
            expires: 7,
            path: "/",
            sameSite: "strict",
        };
        Cookies.set("subsonicToken", token, options);
        Cookies.set("subsonicSalt", salt, options);
        Cookies.set("subsonicUsername", username, options);
    }
}